//+------------------------------------------------------------------+
//|                   Currency Strength Meter.mq4                    |
//|               Copyright 2018, Besarion Turmanauli                |
//|              https://www.mql5.com/en/users/dos.ge                |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Besarion Turmanauli"
#property link      "https://www.mql5.com/en/users/dos.ge"
#property version   "1.00"
//---#property strict


#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 8
#property indicator_plots   8

//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

//--- plot Label2
#property indicator_label2  "Label2"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrViolet
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1

//--- plot Label3
#property indicator_label3  "Label3"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrGreen
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1

//--- plot Label4
#property indicator_label4  "Label4"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrBlue
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1

//--- plot Label5
#property indicator_label5  "Label5"
#property indicator_type5   DRAW_LINE
#property indicator_color5  clrLightGreen
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1

//--- plot Label6
#property indicator_label6  "Label6"
#property indicator_type6   DRAW_LINE
#property indicator_color6  clrLightGray
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1

//--- plot Label7
#property indicator_label7  "Label7"
#property indicator_type7   DRAW_LINE
#property indicator_color7  clrKhaki
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1

//--- plot Label8
#property indicator_label8  "Label8"
#property indicator_type8   DRAW_LINE
#property indicator_color8  clrSandyBrown
#property indicator_style8  STYLE_SOLID
#property indicator_width8  1

//--- indicator buffers
//--- Currencies RSI 
double         Label1Buffer[];
double         Label2Buffer[];
double         Label3Buffer[];
double         Label4Buffer[];
double         Label5Buffer[];
double         Label6Buffer[];
double         Label7Buffer[];
double         Label8Buffer[];

//---Instruments RSI
double         Pair01[];
double         Pair02[];
double         Pair03[];
double         Pair04[];
double         Pair05[];
double         Pair06[];
double         Pair07[];
double         Pair08[];
double         Pair09[];
double         Pair10[];
double         Pair11[];
double         Pair12[];
double         Pair13[];
double         Pair14[];
double         Pair15[];
double         Pair16[];
double         Pair17[];
double         Pair18[];
double         Pair19[];
double         Pair20[];
double         Pair21[];
double         Pair22[];
double         Pair23[];
double         Pair24[];
double         Pair25[];
double         Pair26[];
double         Pair27[];
double         Pair28[];

extern int                 indicatorPeriod = 21;      //Indicator Period
extern ENUM_APPLIED_PRICE appliedPrice=PRICE_CLOSE;   //Indicator Applied Price

#define ISN "Currency Strength Meter ("+string(indicatorPeriod)+")";
int      initial_limit=0;
double   rs = 0.0;
double   rsiint = 0.0;

string Curr01  = "AUD";     //Currency 01
string Curr02  = "CAD";     //Currency 02
string Curr03  = "CHF";     //Currency 03
string Curr04  = "EUR";     //Currency 04
string Curr05  = "GBP";     //Currency 05
string Curr06  = "JPY";     //Currency 06
string Curr07  = "NZD";     //Currency 07
string Curr08  = "USD";     //Currency 08

string Pair01_S  = "AUDCAD"; //Instrument 01
string Pair02_S  = "AUDCHF"; //Instrument 02
string Pair03_S  = "AUDJPY"; //Instrument 03
string Pair04_S  = "AUDNZD"; //Instrument 04
string Pair05_S  = "AUDUSD"; //Instrument 05
string Pair06_S  = "CADCHF"; //Instrument 06
string Pair07_S  = "CADJPY"; //Instrument 07
string Pair08_S  = "CHFJPY"; //Instrument 08
string Pair09_S  = "EURAUD"; //Instrument 09
string Pair10_S  = "EURCAD"; //Instrument 10
string Pair11_S  = "EURCHF"; //Instrument 11
string Pair12_S  = "EURGBP"; //Instrument 12
string Pair13_S  = "EURJPY"; //Instrument 13
string Pair14_S  = "EURNZD"; //Instrument 14
string Pair15_S  = "EURUSD"; //Instrument 15
string Pair16_S  = "GBPAUD"; //Instrument 16
string Pair17_S  = "GBPCAD"; //Instrument 17
string Pair18_S  = "GBPCHF"; //Instrument 18
string Pair19_S  = "GBPJPY"; //Instrument 19
string Pair20_S  = "GBPNZD"; //Instrument 20
string Pair21_S  = "GBPUSD"; //Instrument 21
string Pair22_S  = "NZDCAD"; //Instrument 22
string Pair23_S  = "NZDCHF"; //Instrument 23
string Pair24_S  = "NZDJPY"; //Instrument 24
string Pair25_S  = "NZDUSD"; //Instrument 25
string Pair26_S  = "USDCAD"; //Instrument 26
string Pair27_S  = "USDCHF"; //Instrument 27
string Pair28_S  = "USDJPY"; //Instrument 28

color colorOne   = clrRed;         //Currency 1 Color
color colorTwo   = clrViolet;      //Currency 2 Color
color colorThree = clrGreen;       //Currency 3 Color
color colorFour  = clrBlue;        //Currency 4 Color
color colorFive  = clrLightGreen;  //Currency 5 Color
color colorSix   = clrLightGray;   //Currency 6 Color
color colorSeven = clrKhaki;       //Currency 7 Color
color colorEight = clrSandyBrown;  //Currency 8 Color

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

   if(!LabelCreate(0,Curr01,1,5,20,CORNER_LEFT_LOWER,Curr01,"Arial",12,colorOne))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr02,1,75,20,CORNER_LEFT_LOWER,Curr02,"Arial",12,colorTwo))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr03,1,145,20,CORNER_LEFT_LOWER,Curr03,"Arial",12,colorThree))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr04,1,215,20,CORNER_LEFT_LOWER,Curr04,"Arial",12,colorFour))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr05,1,285,20,CORNER_LEFT_LOWER,Curr05,"Arial",12,colorFive))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr06,1,355,20,CORNER_LEFT_LOWER,Curr06,"Arial",12,colorSix))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr07,1,425,20,CORNER_LEFT_LOWER,Curr07,"Arial",12,colorSeven))
     {
      return (0);
     }
   if(!LabelCreate(0,Curr08,1,495,20,CORNER_LEFT_LOWER,Curr08,"Arial",12,colorEight))
     {
      return (0);
     }

   SetLevelValue(0,20.0);
   SetLevelValue(1,50.0);
   SetLevelValue(2,80.0);
   
//--- indicator buffers mapping
   SetIndexBuffer(0,Label1Buffer);
   SetIndexLabel (0,Curr01);
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,1,colorOne);
   
   SetIndexBuffer(1,Label2Buffer);
   SetIndexLabel (1,Curr02);
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,1,colorTwo);
   
   SetIndexBuffer(2,Label3Buffer);
   SetIndexLabel (2,Curr03);
   SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,1,colorThree);
   
   SetIndexBuffer(3,Label4Buffer);
   SetIndexLabel (3,Curr04);
   SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,1,colorFour);
   
   SetIndexBuffer(4,Label5Buffer);
   SetIndexLabel (4,Curr05);
   SetIndexStyle (4,DRAW_LINE,STYLE_SOLID,1,colorFive);
   
   SetIndexBuffer(5,Label6Buffer);
   SetIndexLabel (5,Curr06);
   SetIndexStyle (5,DRAW_LINE,STYLE_SOLID,1,colorSix);
   
   SetIndexBuffer(6,Label7Buffer);
   SetIndexLabel (6,Curr07);
   SetIndexStyle (6,DRAW_LINE,STYLE_SOLID,1,colorSeven);
      
   SetIndexBuffer(7,Label8Buffer);
   SetIndexLabel (7,Curr08);
   SetIndexStyle (7,DRAW_LINE,STYLE_SOLID,1,colorEight);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,                              // Bar index
   Counted_bars;                       // Number of counted bars

   Counted_bars=IndicatorCounted();    // Number of counted bars
   i=Bars-Counted_bars-1;              // Index of the first uncounted
   if(initial_limit==0){initial_limit=i;}

   while(i>0)
     {//start iteration

      //getting initial values
      double open  = Open[i];
      double high  = High[i];
      double low   = Low[i];
      double close = Close[i];
      
      Label1Buffer[i]=0.0;
      Label2Buffer[i]=0.0;
      Label3Buffer[i]=0.0;
      Label4Buffer[i]=0.0;
      Label5Buffer[i]=0.0;
      Label6Buffer[i]=0.0;
      Label7Buffer[i]=0.0;
      Label8Buffer[i]=0.0;
      
      Pair01[i]= iRSI(Pair01_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair02[i]= iRSI(Pair02_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair03[i]= iRSI(Pair03_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair04[i]= iRSI(Pair04_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair05[i]= iRSI(Pair05_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair06[i]= iRSI(Pair06_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair07[i]= iRSI(Pair07_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair08[i]= iRSI(Pair08_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair09[i]= iRSI(Pair09_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair10[i]= iRSI(Pair10_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair11[i]= iRSI(Pair11_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair12[i]= iRSI(Pair12_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair13[i]= iRSI(Pair13_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair14[i]= iRSI(Pair14_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair15[i]= iRSI(Pair15_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair16[i]= iRSI(Pair16_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair17[i]= iRSI(Pair17_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair18[i]= iRSI(Pair18_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair19[i]= iRSI(Pair19_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair20[i]= iRSI(Pair20_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair21[i]= iRSI(Pair21_S,Period(),indicatorPeriod,appliedPrice,i);
 
      Pair22[i]= iRSI(Pair22_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair23[i]= iRSI(Pair23_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair24[i]= iRSI(Pair24_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair25[i]= iRSI(Pair25_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair26[i]= iRSI(Pair26_S,Period(),indicatorPeriod,appliedPrice,i);

      Pair27[i]= iRSI(Pair27_S,Period(),indicatorPeriod,appliedPrice,i);
      
      Pair28[i]= iRSI(Pair28_S,Period(),indicatorPeriod,appliedPrice,i);
      
      
      Label1Buffer[i] = (200.0+(Pair01[i]+Pair02[i]+Pair03[i]+
                                Pair04[i]+Pair05[i])-(Pair09[i]+
                                Pair16[i]))/7.0;
                         
      Label2Buffer[i] = (500.0+(Pair06[i]+Pair07[i])-(Pair01[i]+
                                Pair10[i]+Pair17[i]+Pair22[i]+
                                Pair27[i]))/7.0;
                          
      Label3Buffer[i] = (600.0+(Pair08[i]-(Pair02[i]+Pair06[i]+
                                Pair11[i]+Pair18[i]-Pair23[i]+
                                Pair26[i])))/7.0;
                         
      Label4Buffer[i] = (000.0+(Pair09[i]+Pair10[i]+Pair11[i]+
                                Pair12[i]+Pair13[i]+Pair14[i]+
                                Pair15[i]))/7.0;
                          
      Label5Buffer[i] = (100.0+(Pair16[i]+Pair17[i]+Pair18[i]+
                                Pair19[i]+Pair20[i]+Pair21[i])-
                                Pair12[i])/7.0;
                         
      Label6Buffer[i] = (700.0-(Pair03[i]+Pair07[i]+Pair08[i]+
                                Pair13[i]+Pair19[i]+Pair24[i]+
                                Pair28[i]))/7.0;
                          
      Label7Buffer[i] = (300.0+(Pair22[i]+Pair23[i]+Pair24[i]+
                                Pair25[i])-(Pair04[i]-Pair14[i]+
                                Pair20[i]))/7.0;
                         
      Label8Buffer[i] = (400.0+(Pair26[i]+Pair27[i]+Pair28[i])-
                               (Pair05[i]+Pair15[i]+Pair21[i]+
                                Pair25[i]))/7.0;
      
      i--;
     }//end iteration

   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   LabelDelete(0,Curr01);
   LabelDelete(0,Curr02);
   LabelDelete(0,Curr03);
   LabelDelete(0,Curr04);
   LabelDelete(0,Curr05);
   LabelDelete(0,Curr06);
   LabelDelete(0,Curr07);
   LabelDelete(0,Curr08);
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Create a text label                                              |
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,               // chart's ID
                 const string            name="Label",             // label name
                 const int               sub_window=0,             // subwindow index
                 const int               x=0,                      // X coordinate
                 const int               y=0,                      // Y coordinate
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                 const string            text="Label",             // text
                 const string            font="Arial",             // font
                 const int               font_size=12,             // font size
                 const color             clr=clrRed,               // color
                 const double            angle=0.0,                // text slope
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type
                 const bool              back=false,               // in the background
                 const bool              selection=false,          // highlight to move
                 const bool              hidden=true,              // hidden in the object list
                 const long              z_order=0)                // priority for mouse click
  {
//--- reset the error value
   ResetLastError();
//--- create a text label
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create text label! Error code = ",GetLastError());
      return(false);
     }
//--- set label coordinates
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set the slope angle of the text
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- set anchor type
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- set color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the label by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//| Delete a text label                                              |
//+------------------------------------------------------------------+
bool LabelDelete(const long   chart_ID=0,   // chart's ID
                 const string name="Label") // label name
  {
//--- reset the error value
   ResetLastError();
//--- delete the label
   if(!ObjectDelete(chart_ID,name))
     {
      Print(__FUNCTION__,
            ": failed to delete a text label! Error code = ",GetLastError());
      return(false);
     }
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+